//ꥹ 11.4 ˥᡼
import java.awt.*;
import javax.swing.*;

public class SimpleAnimation extends JPanel implements Runnable {
    int number = -1;
    int cell = 20;
    int interval;
    Thread animatorThread;
    Image[] image;
    MediaTracker tracker;

    public SimpleAnimation() {
        //᡼Υ
        tracker = new MediaTracker(this);
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        image = new Image[cell];
        for (int i = 1; i <= cell; i++) {
            image[i-1] = 
               toolkit.getImage("rabbit/rabbit" + i + ".gif");
            tracker.addImage(image[i-1], 0);
        }

        interval = 150;                  //δֳ(ߥ)
        setBackground(Color.white);      //ѥͥطʿ
        startAnimation();                //˥᡼γ
    }

    public synchronized void startAnimation() {
       //˥᡼򳫻
       if (animatorThread == null) {
           animatorThread = new Thread(this);
        }
        animatorThread.start();
    }

    public synchronized void stopAnimation() {
        if (animatorThread != null) {//˥᡼󥹥åɤߤ
            animatorThread = null;
        }
    }

    public void run() {
      try{
         tracker.waitForAll();
	  }catch(InterruptedException e){ return; }
      while(animatorThread == Thread.currentThread()){
        number++;  //ɽ륤᡼ֹ̤
        repaint(); //
        try{
          Thread.sleep(interval);
        }catch(InterruptedException e){ break; }
      }
    }

    public void paintComponent(Graphics g) {
       super.paintComponent(g); //طʤ
       int x = getWidth()/2-30;  //ɥΤۤ˥᡼ɽ
       int y = getHeight()/2-30;
       try {
           g.drawImage(image[number%cell], x, y, this);
       } catch (ArrayIndexOutOfBoundsException e) { return; }
                                  //number-1λ褬ƤФ줿㳰
    }

    public static void main(String[] args) {
        JFrame f = new JFrame("Simple Animation");
        SimpleAnimation anime = new SimpleAnimation();
        f.getContentPane().add(anime, BorderLayout.CENTER);
        f.setSize(new Dimension(100, 100));
        f.setVisible(true);
    }
}





